package com.logicbig.example;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import javax.persistence.PersistenceUtil;

public class LoadStateWithPersist {
    private static EntityManagerFactory entityManagerFactory =
            Persistence.createEntityManagerFactory("example-unit");

    public static void main(String[] args) {
        try {
            persistEmployee();
        } finally {
            entityManagerFactory.close();
        }
    }

    public static void persistEmployee() {
        Employee employee = new Employee("Joe", "IT",
                Phone.cell("111-111-1111"), Phone.work("222-222-2222"));
        printLoadState("New Entity", employee);
        EntityManager em = entityManagerFactory.createEntityManager();
        em.getTransaction().begin();
        em.persist(employee);
        printLoadState("After persisting", employee);
        em.getTransaction().commit();
        em.close();
        printLoadState("Detach entity after EntityManger.close()", employee);
    }

    private static void printLoadState(String msg, Employee employee) {
        System.out.printf("-- %s --%n", msg);
        PersistenceUtil pu = Persistence.getPersistenceUtil();
        boolean employeeLoaded = pu.isLoaded(employee);
        System.out.printf("employee loaded: %s%n", employeeLoaded);
        boolean phonesLoaded = pu.isLoaded(employee, "phones");
        System.out.printf("  phones loaded: %s%n", phonesLoaded);
    }
}